SystemOrganization addCategory: #'OB-Web'!

HttpService subclass: #OBHttpService
	instanceVariableNames: 'windows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web'!

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:06'!
createLauncher
	| launcher |
	launcher _ OBWebLauncher new.
	windows add: launcher.
	^ launcher initialResponse! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:00'!
createWindowFor: aBrowser
	| window |
	window _ OBWebWindow model: aBrowser.
	windows add: window.
	^ window! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:03'!
initialize
	super initialize.
	windows _ Set new! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:02'!
notFound: aRequest
	^ HttpResponse 
		status: #notFound
		contents: aRequest url, ' was not found on this server'! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:15'!
processGet: aRequest
	
	aRequest url = '/' ifTrue: [^ self createLauncher].
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | target html]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:08'!
processHttpRequest: aRequest
	^ [(aRequest method = 'GET')
		ifTrue: [self processGet: aRequest]
		ifFalse: [self processPost: aRequest]]
			on: OBBrowseRequest
			do: [:req | req resume: (self createWindowFor: req browser)]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2006 23:29'!
processPost: aRequest
	| message object |
	object _ Json readFrom: aRequest rawPostFields readStream.
	message _ Message
				selector: (object at: 'selector') asSymbol
				arguments: (object at: 'arguments').
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | Json render: (target processMessage: message)]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:13'!
targetForRequest: aRequest ifPresent: aBlock
	| id target |
	id _ aRequest url allButFirst.
	target _ windows
				detect: [:ea | id = ea identifier]
				ifNone: [^ self notFound: aRequest].
	^ HttpResponse fromString: (aBlock value: target)! !

Object subclass: #OBWebLauncher
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web'!

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2006 23:53'!
allowedSelectors
	^ #(openBrowser)! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:26'!
html
	^ '<html>
<head>
	<title>launcher</title>
	<script src="http://localhost/ob/launcher.js"></script>
</head>
<body>
	<a href="javascript:openBrowser()">open browser</a>
</body>
</html>
'! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
id
	^ id! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
identifier
	^ id asString! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
initialResponse
	^ HttpResponse fromUrl: self path! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:06'!
initialize
	id _ UUID new! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2006 23:52'!
openBrowser
	| window |
	window _ OBSystemBrowser open.
	^ window path! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
path
	^ id asString copyWithFirst: $/! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2006 23:44'!
processMessage: aMessage
	^ (self allowedSelectors includes: aMessage selector)
		ifTrue: [aMessage sendTo: self]! !

Object subclass: #OBWebWindow
	instanceVariableNames: 'model id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web'!

!OBWebWindow class methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:01'!
model: aBrowser
	^ self new model: aBrowser! !

!OBWebWindow class methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:01'!
new
	^ self basicNew initialize! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:17'!
html
	^ 'browser'! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:32'!
identifier
	^ id asString! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:02'!
initialize
	id _ UUID new! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:00'!
model
	^ model! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:00'!
model: anObject
	model _ anObject! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:32'!
path
	^ self identifier copyWithFirst: $/! !

!HttpRequest methodsFor: '*ob-web-accessing' stamp: 'cwp 10/19/2006 23:38'!
postData
	| rawPostFields |
	rawPostFields _ self rawPostFields.
	^ rawPostFields isEmpty
		ifTrue: [stream next: self contentLength]
		ifFalse: [rawPostFields]! !
